package client;


//import javax.naming.InitialContext;
//import javax.naming.Context;
//import javax.rmi.PortableRemoteObject;
import javax.jms.*;
import javax.annotation.Resource;
import java.util.Date;

public class Client {

	private int createN = 30;
    private int waitSec = 60; // how long to wait after test run
    private int sleepSec = 15; // how long to sleep in method call

    public static void main(String[] args) throws Exception {
 
        Client client = new Client();
        client.sendMessage();
    }	
	
	
    //============================ MDB test cases follow ========================

    @Resource(mappedName="jms/MDBQueueConnectionFactory")
    private static QueueConnectionFactory qcf;

    @Resource(mappedName="jms/MDBQueue")
    private static Queue mdbQueue;

    public void sendMessage() {
        try {

            QueueConnection queueCon = qcf.createQueueConnection();
            try {
                QueueSession queueSession = queueCon.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
                QueueSender queueSender = queueSession.createSender(null);

                // Send a number of messages
                for (int i = 1; i <= createN; i++) {
                	String msgContent = "msg-"+i;
                    Message msg = queueSession.createTextMessage(msgContent);

                    // The sleepSec tells MDB how long to sleep in the onMessage processing!
                    msg.setIntProperty("sleepSec", sleepSec);

                    queueSender.send(mdbQueue, msg);
                    System.out.println("Sent message " + msgContent + " to MDB at " + new Date());
                }

                // Wait for a while...
                if (waitSec > 0) {
                    System.out.println("Client waiting for " + waitSec + " seconds");
                    Thread.sleep(waitSec * 1000);
                }

            } finally {
                queueCon.close();
            }

        } catch(Exception e) {
            e.printStackTrace();
            return;
        }
        System.out.println("_TEST_PASSED_");
    }
}
